<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-success px-3 py-2" (click)="newRow(); openModal(modal, 'Tipo de Bandas');">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button class="btn btn-danger ml-1 px-4 py-2" (click)="printPDF()">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">

    <kendo-grid [data]="dataGrid"
                [filter]="filter"
                [filterable]="true"
                (filterChange)="filterChange($event)"
                [selectable]="true"
                [navigable]="true"
                [reorderable]="true"
                [resizable]="true"
                [sort]="sort"
                [sortable]="true"
                (sortChange)="sortChange($event)"
                [groupable]="true"
                [group]="groups"
                (groupChange)="groupChange($event)"
                (edit)="editRow($event)"
                (remove)="deleteRow($event)"
                (selectionChange)="selectedRow($event)"
                style="height: 50vh">
      <ng-container *ngIf="dataGrid.length !== 0">
      <kendo-grid-column field="tbanda" title="Tipo" width="90"></kendo-grid-column>
      <kendo-grid-column field="tdesc" title="Descripción" width="320" filterable="false"></kendo-grid-column>
      <kendo-grid-column field="tvig" title="Vigencia" width="150">
                             <ng-template kendoGridCellTemplate let-dataItem>
                               {{dataItem.tvig ? 'Si' : 'No'}}
                             </ng-template>
      </kendo-grid-column>
        <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
          <ng-template kendoGridFilterCellTemplate>
            <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
            </kendo-switch>
          </ng-template>
          <ng-template kendoGridCellTemplate let-dataItem>
            <input type="checkbox" [checked]="dataItem.Inactivo" disabled/>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-command-column title="Actions" width="220">
          <ng-template kendoGridCellTemplate let-isNew="isNew">
            <button kendoGridEditCommand [primary]="true" (click)="openModal(modal, 'Tipo de Bandas');">
              Editar
            </button>
            <button kendoGridRemoveCommand>Eliminar</button>
          </ng-template>
        </kendo-grid-command-column>
      </ng-container>
      <ng-template kendoGridNoRecordsTemplate>
        {{ noRecords }}
      </ng-template>
    </kendo-grid>

    <div class="divider"></div>

    <div class="row mb-1">
      <div class="col-9">
        <label class="w-100 h5"><strong>Rangos Válidos</strong></label>
      </div>
      <div class="col-1">
        <button class="btn btn-success btn-md btn-block" type="button" (click)="rGuardar()"
        [disabled]="ngFormRangos.invalid">
          <i class="fas fa-save mr-2"></i>Guardar
        </button>
      </div>
      <div class="col-1">
        <button class="btn btn-primary btn-md btn-block" type="button" (click)="rNuevo()"
        [disabled]="!flagRango">
          <i class="fas fa-plus mr-2"></i>Nuevo
        </button>
      </div>
      <div class="col-1">
        <button class="btn btn-danger btn-md btn-block" type="button" (click)="rBorrar()">
          Borrar
        </button>
      </div>
    </div>

    <form [formGroup]="ngFormRangos">

      <div class="row">
        <div class="col-3">
          <label>Tipo Banda</label>
          <input type="text" class="form-control" formControlName="tbanda" readonly>
        </div>
        <div class="col-3">
          <label>Desde</label>
          <input type="number" class="form-control" formControlName="iDesde" min="0" max="999999999">
        </div>
        <div class="col-3">
          <label>Hasta</label>
          <input type="number" class="form-control" formControlName="iHasta" min="0" max="999999999">
        </div>
        <div class="col-3">
          <label>Ope.</label>
          <input type="text" class="form-control" formControlName="cUserID" readonly>
        </div>
      </div>

    </form>

    <div *ngIf="!loading">

      <kendo-grid [data]="dataGridR"
                  [selectable]="true"
                  (selectionChange)="gridRslection($event)"
                  style="height: 33vh"
                  class="mt-2">
        <ng-container *ngIf="dataGridR.length !== 0">

          <kendo-grid-column field="tbanda" title="Tipo Banda" width="150"></kendo-grid-column>
          <kendo-grid-column field="iDesde" title="Desde" width="150"></kendo-grid-column>
          <kendo-grid-column field="iHasta" title="Hasta" width="150"></kendo-grid-column>
          <kendo-grid-column field="cUserID" title="Ope." width="150"></kendo-grid-column>

        </ng-container>
        <ng-template kendoGridNoRecordsTemplate>
          {{ noRecords }}
        </ng-template>
      </kendo-grid>

    </div>
  </div>
    <app-loading *ngIf="loading"></app-loading>
  </div>


<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">{{ modalTitle }}</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row" *ngIf="flagShowForm">

        <form [formGroup]="myFormGroup">
          <div class="row d-flex justify-content-between">
            <div class="col-6">
              <label for="tbanda">Tipo</label>
              <input type="text" class="form-control" name="tbanda"
                     [(ngModel)]="myFormGroup.value.tbanda" pattern="[a-zA-Z0-9]*"
                     autofocus formControlName="tbanda" [readOnly]="flagEdit"
                     maxlength="2" minlength="2">
            </div>
            <div class="col-4">
              <label for="Inactivo" class="ml-2">Inactivo</label>
              <kendo-switch class="ml-2" name="Inactivo" [(ngModel)]="myFormGroup.value.Inactivo"
                            formControlName="Inactivo"
                            [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </div>
            <div class="col-12">
              <label class="mt-1" for="tdesc">Descripción</label>
              <input type="text" class="form-control" name="tdesc" pattern="[a-zA-Z0-9 ]*"
                     [(ngModel)]="myFormGroup.value.tdesc" maxlength="30"
                     formControlName="tdesc">
            </div>
            <div class="col-8">
              <label class="mt-1" for="cFormat">Formato</label>
              <input type="text" class="form-control" name="cFormat" pattern="[0-9]*"
                     [(ngModel)]="myFormGroup.value.cFormat" maxlength="15"
                     formControlName="cFormat">
            </div>
            <div class="col-4">
              <label for="tvig" class="ml-2 mt-1">Vigencia</label>
              <kendo-switch class="ml-2" name="tvig" [(ngModel)]="myFormGroup.value.tvig"
                            formControlName="tvig"
                            [onLabel]="'Si'" [offLabel]="'No'">
              </kendo-switch>
            </div>
          </div>
        </form>


    </div>
  </div>
  <div class="modal-footer">
          <button class="btn btn-success" (click)="guardarForm(); c();"
          [disabled]="myFormGroup.status === 'INVALID'">
            <i class="fas fa-save mr-2"></i>Guardar
          </button>
    <button class="btn btn-secondary" (click)="cerrarForm(); c('Close click')">Cerrar</button>
  </div>
</ng-template>
